<?php
error_reporting(E_ALL^E_NOTICE);
include('class.http.php');

define('API_NEWLINE', chr(0x03));  
define('API_DEVIDER', chr(0x04)); 
define('API_KEY', 'YOUR_KEY');   
define('API', "http://127.0.0.1/bugfree/api.php");
define('USER_NAME', 'admin');   
define('USER_PASSWORD', 'e10adc3949ba59abbe56e057f20f883e'); 
define('VIEWVC', 'http://bugfree.svn.sourceforge.net/viewvc/bugfree/');

function parse($result)
{
    $array = array();
    $message = explode(API_NEWLINE, $result);
    $keyArray = explode(API_DEVIDER, $message[1]);
    $valueArray = explode(API_DEVIDER, $message[2]);
    foreach($keyArray as $key => $keyName)
    {
        $array[$keyName] = $valueArray[$key];
    }
    return $array;
}

function encrypt($UserName, $UserPassword, $Rand, $ApiKey = '')
{
    return md5(md5($UserName . $UserPassword) . $ApiKey . $Rand);
}

// get svn message
$fixMessageList = explode(API_DEVIDER, $argv[1]);

// get bug IDs
$fixRegx = '/fix\s*bug\s+(#(\d+)( |,)*)+/i';
preg_match_all($fixRegx, $fixMessageList[1], $regs);
$fixRegx = '/#(\d+)+/i';
preg_match_all($fixRegx, $regs[0][0], $regs);
$BugIdList = array();
if(is_array($regs[1]))
{
    $BugIdList = $regs[1];
}
$BugIdList = array_unique($BugIdList);
if(count($BugIdList) <= 0) exit;

// create replynote
$note = '';
$note = $fixMessageList[0] . "\n\n";
$fileList = explode("\n", $fixMessageList[3]);
$rev = $fixMessageList[2];
$pre = $rev - 1;
foreach($fileList as $file)
{
    preg_match_all('/(\w)(\s+)(.*)/', $file, $regs);
    $action = trim($regs[1][0]);
    $fileName = trim($regs[3][0]);
    if($fileName == '') continue;
    $note .= $file;
    // u can change this url's link 
    $note .= '  [url=' . VIEWVC . $fileName . '?r1='. $pre . '&sortdir=down&r2=' . $rev . '&sortby=log][diff][/url]';
    $note .= "\n";
}

// get session
$http = new Http();
$http->addParam('mode' , 'getsid');
$http->execute(API);
$ApiArray = parse($http->result);
$sessionname = $ApiArray['sessionname'];
$sessionid = $ApiArray['sessionid'];
$rand = $ApiArray['rand'];

// login
$http = new Http();
$http->addParam('mode' , 'login');
$http->addParam($sessionname , $sessionid);
$http->addParam('username' , USER_NAME);
$http->addParam('auth' , encrypt(USER_NAME,USER_PASSWORD,$rand,API_KEY));
$http->execute(API);
$ApiArray = parse($http->result);

// insert replynot for bugs
foreach($BugIdList as $BugID)
{
    $http = new Http();
    $http->addParam('mode' , 'updatebug');
    $http->addParam('BugID' , $BugID);
    $http->addParam('ReplyNote' , $note);
    $http->addParam($sessionname , $sessionid);
    $http->execute(API);
}
?>
